// ==UserScript==
// @name 			OpenNewTab.uc.js
// @description 	新規タブで開く（カレントタブが空白タブの場合再利用）
// @include 		main
// @compatibility	Firefox 65+
// @version        2019/02/03 20:30 fix to fail with continuous open bookmarks/history
// @version        2018/11/04 22:30 fix Bug 1502069, use selectedTab.isEmpty insted isTabEmpty()
// ==/UserScript==
(function() {

    if(location.href !== 'chrome://browser/content/browser.xhtml') return;

  // 検索ボックスから（マウスクリック）
  // searchbar.xml
    var searchbar = document.getElementById("searchbar");
    if (searchbar) {
      searchbar.__org_handleSearchCommandWhere = searchbar.handleSearchCommandWhere;
      searchbar.handleSearchCommandWhere = function(aEvent, aEngine, aWhere, aParams) {
        if (gBrowser && (xxxCheckMaybeProcessing()
            || !gBrowser.selectedTab.isEmpty )) {
          aWhere = 'tab';
        }
        return this.__org_handleSearchCommandWhere(aEvent, aEngine, aWhere, aParams);
      }
    }

  // 履歴から（サイドバー含む）
  // modules\PlacesUIUtils.jsm
    if (!/__org_openNodeIn/.test(PlacesUIUtils._openNodeIn.toString())) {
      PlacesUIUtils.__org_openNodeIn = PlacesUIUtils._openNodeIn;
      PlacesUIUtils._openNodeIn = function(aNode, aWhere, aWindow, aPrivate) {
        let win = Services.wm.getMostRecentWindow("navigator:browser");
        if (aWhere == 'current'
           && win.gBrowser && (win.xxxCheckMaybeProcessing() 
           || !win.gBrowser.selectedTab.isEmpty)) {
          aWhere = 'tab';
        }
        if (/^javascript:/.test(aNode.uri)) aWhere = 'current';
        return this.__org_openNodeIn(aNode, aWhere, aWindow, aPrivate);
      }
    }

    // safty fallback
    window.xxxMaybeProcessing = false;
    window.xxxMaybeProcessingTimer = null;
    window.xxxCheckMaybeProcessing = function() {
      clearTimeout(xxxMaybeProcessingTimer);
      // xxx After adding a tab, the tab is considered busy for 500ms
      xxxMaybeProcessingTimer = setTimeout(() => {xxxMaybeProcessing = false;}, 500);
      let MaybeProcessing = xxxMaybeProcessing;
      if (!xxxMaybeProcessing) {
        xxxMaybeProcessing = true;
      }
      return MaybeProcessing;
    }

})();